<template>
  <navbar
    :page-title="pageTitle"
    :breadcrumb-menu="breadcrumbMenu"
    :is-secondary-page="isSecondaryPage"
  >
    <div v-if="pageType === 'Index'">
      <b-button
        type="submit"
        variant="success"
        class="add-employee-button"
        title="Add Employee"
        @click="onClickCreate"
      >
        <span>Add New Employee</span>
      </b-button>
    </div>

    <div v-else-if="pageType === 'Create'">
      <b-button
        class="button secondary clear"
        title="Cancel"
        @click="onHandleFormReset"
      >
        Cancel
      </b-button>
      <b-button
        class="button secondary shaddy"
        title="Add Employee"
        @click="onSubmit"
      >
        Add Employee
      </b-button>
    </div>

    <div v-else-if="pageType === 'View'">
      <b-button
        class="add-employee-button"
        title="Edit Info"
        @click="onClickEdit"
      >
        Edit Info
      </b-button>
    </div>
  </navbar>
</template>

<script lang="ts">
import Vue from 'vue'
import Navbar from '@/components/Navbar/Navbar.vue'

export default Vue.extend({
  name: 'EmployeeNavbar',
  components: { Navbar },
  props: {
    pageTitle: {
      type: String,
      default: ''
    },
    breadcrumbMenu: {
      type: Array,
      default: () => []
    },
    isSecondaryPage: {
      type: Boolean,
      default: false
    },
    pageType: {
      type: String,
      default: ''
    },
    currentEmployeeId: {
      type: String,
      default: ''
    }
  },
  methods: {
    onHandleFormReset() {
      this.$emit('handleFormReset')
    },
    onSubmit() {
      this.$emit('submit')
    },
    onClickCreate() {
      this.$emit('goTo', 'employees-create')
    },
    onClickEdit() {
      this.$emit('goTo', 'employees-edit-id', this.currentEmployeeId)
    }
  }
})
</script>

<style>
.add-employee-button {
  background-color: #13bc74;
  color: #fefefe;
  font-size: 0.99rem;
  flex: 0 0 auto;
  padding: 1em 2em;
  border-radius: 1.5rem;
  transition: background-color 0.25s ease-out, color 0.25s ease-out;
  line-height: 1;
  text-align: center;
  cursor: pointer;
}
.add-employee-button:hover {
  box-shadow: 0px 3px 12px rgba(0, 0, 0, 0.15);
  position: relative;
  top: -0.03em;
  left: 0.03em;
}

.button {
  display: inline-block;
  vertical-align: middle;
  margin: 0 1rem 1rem 0;
  font-family: inherit;
  padding: 1em 2em;
  -webkit-appearance: none;
  border: 1px solid transparent;
  border-radius: 1.5rem;
  transition: background-color 0.25s ease-out, color 0.25s ease-out;
  font-size: 0.99rem;
  line-height: 1;
  text-align: center;
  cursor: pointer;
  background-color: #13bc74;
  color: #fefefe;
}

[data-whatinput='mouse'] .button {
  outline: 0;
}

.button:hover,
.button:focus {
  background-color: #31ea9b;
  color: #fefefe;
}

.button.primary,
.button.secondary {
  color: #fff;
}

.button.primary:hover,
.button.secondary:hover {
  color: #fff;
  border-color: #ff9051;
}

.button.secondary {
  background-color: #ff9051;
}

.button.secondary:hover,
.button.secondary:focus {
  background-color: #ff650e;
}

.button.clear {
  border: 1px solid #13bc74;
  color: #13bc74;
}

.button.clear,
.button.clear.disabled,
.button.clear[disabled],
.button.clear:hover,
.button.clear:hover.disabled,
.button.clear:hover[disabled],
.button.clear:focus,
.button.clear:focus.disabled,
.button.clear:focus[disabled] {
  border-color: transparent;
}

.button.clear,
.button.clear:hover,
.button.clear:focus {
  background-color: transparent;
}

.button.clear.secondary {
  color: #ff9051;
}

.button.clear.secondary:hover,
.button.clear.secondary:focus {
  color: #a83d00;
}

.button.shaddy:hover {
  box-shadow: 0px 3px 12px rgba(0, 0, 0, 0.15);
  position: relative;
  top: -0.03em;
  left: 0.03em;
}
</style>
